;uses specular-mapping And the dot3_to_gloss function, to create gloss-mapping
;different specular-colors generate different gloss-effects
Include"bsm_lib.bb" ; including the Library
Include"mesh_lib.bb"
Graphics3D 1024,768,0,1

scaletex#=0.125

bmap=loadtexture("fels-geschliff1-dot3.jpg",1+8) ; loading Bumpmap
TextureBlend bmap,4
ScaleTexture bmap,scaletex#,scaletex#

;glossmap=loadtexture("fels-geschliff1-dot3.jpg") ; loading Bumpmap

glossmap=bsm_dot3_to_gloss(bmap,1)
ScaleTexture glossmap,scaletex#,scaletex#
TextureBlend glossmap,4

colmap=loadtexture("fels-geschliff1.jpg",1+8) ; loading Colormap
TextureBlend colmap,2
ScaleTexture colmap,scaletex#,scaletex#

AmbientLight 10,10,10
light=createsphere() ; create Light-Dummy
ScaleEntity light,10,10,10
EntityFX light,1
dxlight=createlight(2,light)
LightColor dxlight,200,200,200
LightRange dxlight,230

light2=createsphere() ; create Light-Dummy2
ScaleEntity light2,10,10,10
EntityFX light2,1
EntityColor light2,255,0,0
dxlight2=createlight(2,light2)
LightColor dxlight2,200,0,0
LightRange dxlight2,200

sky=createsphere() ; create Background
ScaleEntity sky,1000,1000,1000
FlipMesh sky : EntityFX sky,1
skytex=loadtexture("stars2.jpg",1+8)
ScaleTexture skytex,.125,.125
EntityTexture sky,skytex

cam=createcamera() 
CameraRange cam,0.1,10000
CameraClsMode cam,0,1
bsm_debugger(1) ;BSM Error output to DebugLog

bsm_init("norm.tga") ; initialise the BSM-Library
bsm_set_maincamera(cam)

bsm_set_updates(1)

pivot=createpivot() ;dummy-point to join the three objects


obj=loadmesh("asteroid4.3ds",pivot)  ;  create bumpmapped object
DebugLog MeshWidth(obj)
FitMesh obj,-.5,-.5,-.5,1,1,1,1
testobj=copymesh(obj)
DebugLog MeshWidth(obj)
RotateEntity obj,0,90,0
EntityFX obj,1
ScaleEntity obj,10,10,10
MSH_ExpandMesh(obj,.0025) 
DebugLog MeshWidth(obj)
EntityBlend obj,3

obj2=loadmesh("asteroid4.3ds",pivot)  ;  create normal object
FitMesh obj2,-.5,-.5,-.5,1,1,1,1
RotateEntity obj2,0,90,0
ScaleEntity obj2,10,10,10


obj3=loadmesh("asteroid4.3ds",pivot)  ;  create bumpmapped object
FitMesh obj3,-.5,-.5,-.5,1,1,1,1
RotateEntity obj3,0,90,0
EntityFX obj3,1
EntityColor obj3,128,128,128
ScaleEntity obj3,10,10,10
MSH_ExpandMesh(obj3,.005) 
EntityBlend obj3,3

spectex=bsm_make_specular(128,9+256,1) ; makes a specular-texture
TextureBlend spectex,2

cmap=bsm_create_cmap(obj,1,0) ; generate a BSM-Cubemap And give it to the object at layer 0
TextureBlend cmap,1 ; let the cubemap not blend with any layer beneath it
bsm_setlight(cmap,dxlight,1,2,1) ; set the Light-Dummy as lightsource for the BSM-Cubemap
bsm_setlight(cmap,dxlight2,2,2,.25) ; set the Light-Dummy2 as lightsource for the BSM-Cubemap
bsm_set_angle(cmap,1) ; set difference between actual and last angle, that forces an update
bsm_Z_offset(cmap,180)
bsm_update(cmap) ; force a manual update
bsm_set_auto(cmap,1) ; set auto-update on for this BSM-Cubemap

smap=bsm_create_smap(obj3) ; generate a Specular-Cubemap And give it to the glossmapped object at layer 0
TextureBlend smap,3 ; let the cubemap not blend with any layer beneath it
bsm_setlight(smap,dxlight,1,2,1) ; set the Light-Dummy as lightsource for the BSM-Cubemap
bsm_setlight(smap,dxlight2,2,2,.5) ; set the Light-Dummy2 as lightsource For the BSM-Cubemap
bsm_set_specular_texture(smap,1,spectex)
bsm_set_specular_texture(smap,2,spectex)
bsm_set_specular_color(smap,2,0,255,64) ; green colors lights flat parts of the glossmap
bsm_set_specular_color(smap,1,255,0,128) ; red colors lights rising parts of the glossmap
bsm_set_specular_size(smap,1,4,4)
bsm_set_specular_size(smap,2,2,2)
bsm_set_angle(smap,0.5) ; set difference between actual And last angle, that forces an update
bsm_update(smap) ; force a manual update
bsm_set_auto(smap,1) ; set auto-update on for this BSM-Cubemap

EntityTexture obj2,colmap ; texture normal earth-object with the texture

EntityTexture obj,bmap,0,1 ;texture object with the bump texture
EntityTexture obj,colmap,0,2 ;texture object with the texture

EntityTexture obj3,smap,0,0 ;texture object with the specular texture
EntityTexture obj3,glossmap,0,1 ;texture object with the gloss texture

PositionEntity cam,0,0,3

time=millisecs()
time2=millisecs()
w#=90
auto=1
tblend=1

While KeyHit(1)=0  ; mainloop

count=count+1
If MilliSecs()-time>1000 Then fps=count : count=0 : time=millisecs() ; calculate FPS
looptime#=(millisecs()-time2)/1000.0 : time2=millisecs()

TurnEntity pivot,10*looptime#,10*looptime#,0

If KeyDown(203)=1 Then w#=w#+.5
If KeyDown(205)=1 Then w#=w#-.5
If KeyDown(200)=1 Then y#=y#-20*looptime#
If KeyDown(208)=1 Then y#=y#+20*looptime#

w#=w#+5*looptime#

x#=sin(w#)*530 : z#=cos(w#)*530
PositionEntity light,x#,0,z#  ; moves light around
x#=sin(w#*5)*500 : z#=cos(w#*5)*500
PositionEntity light2,x#,x#/2,z#  ; moves light around


PositionEntity cam,0,y#,10 ; moves camera up/down
PointEntity cam,obj

test=bsm_update_all(1) ; updating all active BSM-Cubemaps


UpdateWorld()

RenderWorld()

Text 10,10,"FPS "+fps
If test>0 Then Text 10,20,"Update yes" Else Text 10,20,"Update no"
Flip(0)

Wend




