; shows the primary function of the BSM-Library. Adjust the correct light direction for bumpmapping.
; uses bsm_set_amblight to set a simple ambient lightlevel
Include"bsm_lib.bb" ; including the Library
Graphics3D 800,600,0,1

bmap=loadtexture("earthbump1k.jpg",1+8+256) ; loading Bumpmap
TextureBlend bmap,4

colmap=loadtexture("BlueMarbleat1638.jpg",1+8+256) ; loading Colormap
TextureBlend colmap,2

light=createsphere() ; create Light-Dummy
EntityFX light,1

sky=createsphere() ; create Background
ScaleEntity sky,1000,1000,1000
FlipMesh sky
skytex=loadtexture("stars2.jpg",1+8+256)
ScaleTexture skytex,.125,.125
EntityTexture sky,skytex

cam=createcamera() 

bsm_init("norm.tga") ; initialise the BSM-Library
bsm_set_maincamera(cam)
bsm_debugger(1)

obj=createsphere(32)  ;  create earth
RotateEntity obj,0,90,0
EntityFX obj,1

cmap=bsm_create_cmap(obj,1,0) ; generate a BSM-Cubemap and give it to the earth-object at layer 0
bsm_setlight(cmap,light,1,2,1) ; set the Light-Dummy as lightsource for the BSM-Cubemap
bsm_set_amblight(cmap,.1) ; sets the ambient lightlevel for this BSM_Cubemap
bsm_set_angle(cmap,1) ; set difference between actual and last angle, that forces an update
bsm_update(cmap) ; force a manual update
bsm_set_auto(cmap,1) ; set auto-update on for this BSM-Cubemap

EntityTexture obj,bmap,0,1 ;texture earth with a bumpmap
EntityTexture obj,colmap,0,2 ;texture earth with a colormap

PositionEntity cam,0,0,3

time=millisecs()
time2=millisecs()
w#=90
auto=1
tblend=1

While KeyHit(1)=0  ; mainloop

count=count+1
If MilliSecs()-time>1000 Then fps=count : count=0 : time=millisecs() ; calculate FPS
looptime#=(millisecs()-time2)/1000.0 : time2=millisecs()

TurnEntity obj,10*looptime#,10*looptime#,0

If KeyDown(203)=1 Then w#=w#+.5
If KeyDown(205)=1 Then w#=w#-.5
If KeyDown(200)=1 Then y#=y#-2*looptime#
If KeyDown(208)=1 Then y#=y#+2*looptime#

w#=w#+5*looptime#

If KeyHit(57)=1 Then tblend=1-tblend : TextureBlend colmap,1+tblend ; switches bumpmapping on/off
If KeyHit(28)=1 Then auto=1-auto : bsm_set_auto(cmap,auto) ; switches auto-update on/off

x#=sin(w#)*13 : z#=cos(w#)*13
PositionEntity light,x#,0,z#  ; moves light around
PointEntity light,obj
PositionEntity cam,0,y#,2 ; moves camera up/down
PointEntity cam,obj

test=bsm_update_all(1) ; updating all active BSM-Cubemaps

UpdateWorld()
RenderWorld()
Text 10,10,"FPS "+fps
If test=1 Then Text 10,20,"Update yes" Else Text 10,20,"Update no"
Flip(0)

Wend








